diff -ru hurd-0.0/proc/host.c hurd-0.1/proc/host.c
--- hurd-0.0/proc/host.c	Thu Apr 25 15:35:48 1996
+++ hurd-0.1/proc/host.c	Thu Sep  5 11:03:35 1996
@@ -47,7 +47,6 @@
 {
   char *name;
   char *version;
-  char *release;
 } *server_versions;
 int nserver_versions, server_versions_nalloc;
 
@@ -271,14 +270,17 @@
 
 /* Version information handling.
 
-   A server registers its name, release, and version with
-   startup_register_version.  The uname version string is composed of all
-   the server names and versions.  The uname release is composed of the
-   differing server releases in order of decreasing popularity (just one if
-   they all agree).
+   A server registers its name and version with
+   startup_register_version.
+
+   The uname release is the most popular version number.
+
+   The uname version string is composed of all the server names and
+   versions, omitting special mention of those which match the uname
+   release, plus the kernel version string. */
+   
+char *kernel_name, *kernel_version;
 
-   The Hurd release comes from <hurd/hurd_types.h> and
-   is compiled into proc as well as the other servers. */
 
 /* Rebuild the uname version string.  */
 static void
@@ -314,73 +316,59 @@
 	*p++ = '/';
     }
 
-  /* Collect all the differing release strings and count how many
+  /* Collect all the differing version strings and count how many
      servers use each.  */
-  struct release
+  struct version
     {
-      const char *release;
+      const char *version;
       unsigned int count;
-    } releases[nserver_versions];
-  int compare_releases (const void *a, const void *b)
+    } versions[nserver_versions];
+  int compare_versions (const void *a, const void *b)
     {
-      return (((const struct release *) b)->count -
-	      ((const struct release *) a)->count);
+      return (((const struct version *) b)->count -
+	      ((const struct version *) a)->count);
     }
-  unsigned int nreleases = 0;
+  unsigned int nversions = 0;
 
   for (i = 0; i < nserver_versions; ++i)
     {
-      for (j = 0; j < nreleases; ++j)
-	if (! strcmp (releases[j].release, server_versions[i].release))
+      for (j = 0; j < nversions; ++j)
+	if (! strcmp (versions[j].version, server_versions[i].version))
 	  {
-	    ++releases[j].count;
+	    ++versions[j].count;
 	    break;
 	  }
-      if (j == nreleases)
+      if (j == nversions)
 	{
-	  releases[nreleases].release = server_versions[i].release;
-	  releases[nreleases].count = 1;
-	  ++nreleases;
+	  versions[nversions].version = server_versions[i].version;
+	  versions[nversions].count = 1;
+	  ++nversions;
 	}
     }
 
-  /* Sort the releases in order of decreasing popularity.  */
-  qsort (releases, nreleases, sizeof (struct release), compare_releases);
+  /* Sort the versions in order of decreasing popularity.  */
+  qsort (versions, nversions, sizeof (struct version), compare_versions);
 
   /* Now build the uname strings.  */
 
-  initstr (uname_info.release);
-  for (i = 0; i < nreleases; ++i)
-    addstr (NULL, releases[i].release);
-
-  if (p > end)
-#ifdef notyet
-    syslog (LOG_EMERG,
-	    "_UTSNAME_LENGTH %u too short; inform bug-glibc@prep.ai.mit.edu\n",
-	    p - end)
-#endif
-      ;
-  else
-    p[-1] = '\0';
-  end[-1] = '\0';
+  /* release is the most popular version */
+  strcpy (uname_info.release, versions[0].version);
+  
+  initstr (uname_info.version);
 
-  for (i = 2; i < nserver_versions; i++)
-    if (strcmp (server_versions[i].version, server_versions[1].version))
-      break;
+  addstr (kernel_name, kernel_version);
 
-  initstr (uname_info.version);
+  if (versions[0].count > 1)
+    addstr ("Hurd", versions[0].version);
 
-  if (i == nserver_versions)
-    {
-      /* All the servers after [0] (the microkernel version)
-	 are the same, so just write one "hurd" version.  */
-      addstr (server_versions[0].name, server_versions[0].version);
-      addstr ("Hurd", server_versions[1].version);
-    }
-  else
+  /* Now, for any which differ (if there might be any), write it out
+     separately. */
+  if (versions[0].count != nserver_versions)
     for (i = 0; i < nserver_versions; i++)
-      addstr (server_versions[i].name, server_versions[i].version);
-
+      if (versions[0].count == 1
+	  || strcmp (server_versions[i].version, versions[0].version))
+	addstr (server_versions[i].name, server_versions[i].version);
+    
   if (p > end)
 #ifdef notyet
     syslog (LOG_EMERG,
@@ -393,13 +381,12 @@
   end[-1] = '\0';
 }
 
-      
 void
 initialize_version_info (void)
 {
   extern const char *const mach_cpu_types[];
   extern const char *const mach_cpu_subtypes[][32];
-  kernel_version_t kernel_version;
+  kernel_version_t kv;
   char *p;
   struct host_basic_info info;
   unsigned int n = sizeof info;
@@ -419,23 +406,21 @@
   server_versions = malloc (sizeof (struct server_version) * 10);
   server_versions_nalloc = 10;
 
-  err = host_kernel_version (mach_host_self (), kernel_version);
+  err = host_kernel_version (mach_host_self (), kv);
   assert (! err);
-  p = index (kernel_version, ':');
+  p = index (kv, ':');
   if (p)
     *p = '\0';
-  p = index (kernel_version, ' ');
+  p = index (kv, ' ');
   if (p)
     *p = '\0';
-  server_versions[0].name = strdup (p ? kernel_version : "mach");
-  server_versions[0].release = strdup (HURD_RELEASE);
-  server_versions[0].version = strdup (p ? p + 1 : kernel_version);
+  kernel_name = strdup (p ? kv : "mach");
+  kernel_version = strdup (p ? p + 1 : kv);
 
   server_versions[1].name = strdup (OUR_SERVER_NAME);
-  server_versions[1].release = strdup (HURD_RELEASE);
   server_versions[1].version = strdup (OUR_VERSION);
 
-  nserver_versions = 2;
+  nserver_versions = 1;
 
   rebuild_uname ();
   
@@ -471,11 +456,8 @@
       {
 	/* Change this entry.  */
 	free (server_versions[i].version);
-	free (server_versions[i].release);
 	server_versions[i].version = malloc (strlen (version) + 1);
-	server_versions[i].release = malloc (strlen (version) + 1);
 	strcpy (server_versions[i].version, version);
-	strcpy (server_versions[i].release, release);
 	break;
       }
   if (i == nserver_versions)
@@ -491,11 +473,8 @@
       server_versions[nserver_versions].name = malloc (strlen (name) + 1);
       server_versions[nserver_versions].version = malloc (strlen (version) 
 							  + 1);
-      server_versions[nserver_versions].release = malloc (strlen (release)
-							  + 1);
       strcpy (server_versions[nserver_versions].name, name);
       strcpy (server_versions[nserver_versions].version, version);
-      strcpy (server_versions[nserver_versions].release, release);
       nserver_versions++;
     }
   
diff -ru hurd-0.0/release/ChangeLog hurd-0.1/release/ChangeLog
--- hurd-0.0/release/ChangeLog	Mon Aug  5 20:30:22 1996
+++ hurd-0.1/release/ChangeLog	Fri Aug 16 10:50:10 1996
@@ -1,3 +1,13 @@
+Fri Aug 16 10:50:01 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* SETUP: Set `PATH'.
+
+Wed Aug 14 16:23:11 1996  Miles Bader  <miles@gnu.ai.mit.edu>
+
+	* tool-Makefile (INSTALL, IMAGE): New variables.
+	Change all rules &c to use these variables instead of
+	`../hurdinst' and `hurd-image'.
+
 Mon Aug  5 11:44:30 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
 
 	* SETUP: Put `r' before BOOT_DEV in call to INSTALL-GRUB-MBR.
diff -ru hurd-0.0/release/SETUP hurd-0.1/release/SETUP
--- hurd-0.0/release/SETUP	Mon Aug  5 20:29:49 1996
+++ hurd-0.1/release/SETUP	Fri Aug 16 10:49:50 1996
@@ -1,6 +1,8 @@
 #!/bin/bash
 # Setup critical hurd translators
 
+PATH=/bin:/sbin
+
 BOOT_DEV="$1"
 if [ ! "$BOOT_DEV" ]; then
   echo "No device to install a boot loader was specified."
diff -ru hurd-0.0/release/SOURCES.0.0 hurd-0.1/release/SOURCES.0.0
--- hurd-0.0/release/SOURCES.0.0	Mon Aug  5 13:37:09 1996
+++ hurd-0.1/release/SOURCES.0.0	Thu Aug  8 17:55:05 1996
@@ -2,7 +2,7 @@
 
 
 The following packages were built from the sources of the indicated
-version in ftp://prep.gnu.ai.edu/pub.gnu according to the provided
+version in ftp://prep.gnu.ai.edu/pub/gnu according to the provided
 instructions without modification:
 
 autoconf (2.10)
diff -ru hurd-0.0/release/tool-Makefile hurd-0.1/release/tool-Makefile
--- hurd-0.0/release/tool-Makefile	Mon Jul  8 16:21:02 1996
+++ hurd-0.1/release/tool-Makefile	Thu Aug 15 16:58:29 1996
@@ -3,6 +3,9 @@
 export GNUTARGET=elf32-i386
 export OBJCOPY=i386-gnu-objcopy
 
+INSTALL=install
+IMAGE=image
+
 BF=bfloppy-image
 RF=rfloppy-image
 
@@ -11,14 +14,14 @@
 bfloppy-bootfs = ufs
 bfloppy-bootprogs = kernel bootstrap
 
-$(BF)/boot/servers.boot: hurd-image/boot/floppy.boot
+$(BF)/boot/servers.boot: $(IMAGE)/boot/floppy.boot
 	-rm -f $@
 	@test -d $(@D) || mkdir -p $(@D)
 	cp $< $@
 
-$(BF)/%/: hurd-image/%/
+$(BF)/%/: $(IMAGE)/%/
 	test -d $@ || mkdir -p $@
-$(BF)/%: hurd-image/%
+$(BF)/%: $(IMAGE)/%
 	-rm -f $@
 	@test -d $(@D) || mkdir -p $(@D)
 	ln $< $@ || cp $< $@
@@ -46,27 +49,27 @@
 libc-USERS =
 libc-DEPS =
 
-$(RF)/lib/libc.so: hurd-image/lib/libc.so hurd-image/lib/libhurduser.so hurd-image/lib/libmachuser.so $(libc-satisfies:%=hurd-image/%)
+$(RF)/lib/libc.so: $(IMAGE)/lib/libc.so $(IMAGE)/lib/libhurduser.so $(IMAGE)/lib/libmachuser.so $(libc-satisfies:%=$(IMAGE)/%)
 	mksmallso $(smallso-LDFLAGS) \
-	  $@ $(libc-obj-dir)/libc_pic.a '-Lhurd-image/lib -lhurduser -lmachuser' \
+	  $@ $(libc-obj-dir)/libc_pic.a '-L$(IMAGE)/lib -lhurduser -lmachuser' \
 	  $(filter-out $(firstword $^),$^)
 
-$(RF)/lib/libhurduser.so: $(RF)/lib/libc.so $(libc-satisfies:%=hurd-image/%)
-	mksmallso $(smallso-LDFLAGS) $@ $(libc-obj-dir)/libhurduser_pic.a -Lhurd-image/lib -lmachuser $(filter-out $(firstword $^),$^)
+$(RF)/lib/libhurduser.so: $(RF)/lib/libc.so $(libc-satisfies:%=$(IMAGE)/%)
+	mksmallso $(smallso-LDFLAGS) $@ $(libc-obj-dir)/libhurduser_pic.a -L$(IMAGE)/lib -lmachuser $(filter-out $(firstword $^),$^)
 
-$(RF)/lib/libmachuser.so: $(RF)/lib/libc.so $(RF)/lib/libhurduser.so $(libc-satisfies:%=hurd-image/%)
+$(RF)/lib/libmachuser.so: $(RF)/lib/libc.so $(RF)/lib/libhurduser.so $(libc-satisfies:%=$(IMAGE)/%)
 	mksmallso $(smallso-LDFLAGS) $@ $(libc-obj-dir)/libmachuser_pic.a '' $(filter-out $(firstword $^),$^)
 
 $(addprefix $(RF)/,$(rfloppy-hurd:%=hurd/%) $(rfloppy-progs:%=bin/%)): \
-  $(RF)/%: hurd-image/%
+  $(RF)/%: $(IMAGE)/%
 	@test -d $(@D) || mkdir -p $(@D)
 	gzip -9v -c $< > $@.new
 	chmod 555 $@.new
 	mv -f $@.new $@
 
-$(RF)/%/: hurd-image/%/
+$(RF)/%/: $(IMAGE)/%/
 	test -d $@ || mkdir -p $@
-$(RF)/%: hurd-image/%
+$(RF)/%: $(IMAGE)/%
 	-rm -f $@
 	@test -d $(@D) || mkdir -p $(@D)
 	ln $< $@ || cp $< $@
@@ -96,7 +99,7 @@
 	vnconfig -u ${VND_DEV} $@.new
 	mv -f $@.new $@
 
-hurd-image.tar: hurd-image hurd-image.stamp
+$(IMAGE).tar: $(IMAGE) $(IMAGE).stamp
 	tar cof $@ $<
 
 %.gz: %
@@ -108,17 +111,14 @@
 	mv -f $@.new $@
 
 
-instdirs := $(patsubst ../hurdinst/%,%,\
-		       $(filter-out ../hurdinst,\
-				    $(shell find ../hurdinst -type d -print \
+instdirs := $(patsubst $(INSTALL)/%,%,\
+		       $(filter-out $(INSTALL),\
+				    $(shell find $(INSTALL) -type d -print \
 					    | sort -r)))
 
-hurd-image/%/.stamp: ../hurdinst/%
+$(IMAGE)/%/.stamp: $(INSTALL)/%
 	@./install-stripped -N $@ $< $(@D)
 	@echo $< `date` > $@
 	@echo updated $(@D)/
-hurd-image.stamp: $(instdirs:%=hurd-image/%/.stamp); touch $@
-hurd-image: hurd-image.stamp
-
-
-	
\ No newline at end of file
+$(IMAGE).stamp: $(instdirs:%=$(IMAGE)/%/.stamp); touch $@
+$(IMAGE): $(IMAGE).stamp
Only in hurd-0.1: sh-version.sed
diff -ru hurd-0.0/sutils/ChangeLog hurd-0.1/sutils/ChangeLog
--- hurd-0.0/sutils/ChangeLog	Thu Aug  1 16:29:54 1996
+++ hurd-0.1/sutils/ChangeLog	Thu Sep  5 12:21:12 1996
@@ -1,3 +1,38 @@
+Thu Sep  5 11:40:00 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* Makefile: Use $(top_srcdir)/sh-version.sed to make executables
+	from .sh files.
+
+	* fsck.c: Include <version.h>.
+ 	(argp_program_version): Define with STANDARD_HURD_VERSION. 
+	* halt.c: Likewise.
+	* reboot.c: Likewise.
+
+Tue Aug 27 12:06:55 1996  Miles Bader  <miles@gnu.ai.mit.edu>
+
+	* reboot.c, halt.c (main): Add argument parsing.
+	(argp_program_version): New variable.
+	<argp.h>, <hurd.h>: New includes.
+	* Makefile (fsck): Remove dependency on libshouldbeinlibc.a.
+	(reboot halt fsck): Add dependency on libshouldbeinlibc.a.
+
+Mon Aug 19 15:17:38 1996  Miles Bader  <miles@gnu.ai.mit.edu>
+
+	* fsck.c (doc): Supply a useful value.
+
+Wed Aug 14 13:32:12 1996  Miles Bader  <miles@gnu.ai.mit.edu>
+
+	* e2os.sh: Add `;' before last commands inside { } pairs.
+	(OS_FREEBSD, OS_LITES): New variables.
+	Add symbolic names for freebsd & lites.
+
+Mon Aug 12 10:51:24 1996  Miles Bader  <miles@gnu.ai.mit.edu>
+
+	* e2os.sh: New file.
+	* Makefile (targets): Add e2os.
+	(SRCS): Add $(SCRIPTS).
+	(special-targets, SCRIPTS, LCLHDRS): New variables.
+
 Thu Aug  1 16:29:31 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
 
 	* clookup.c (file_name_lookup_carefully/lookup): When appending
diff -ru hurd-0.0/sutils/Makefile hurd-0.1/sutils/Makefile
--- hurd-0.0/sutils/Makefile	Wed Jun 19 16:14:20 1996
+++ hurd-0.1/sutils/Makefile	Thu Sep  5 12:21:40 1996
@@ -20,17 +20,21 @@
 dir := sutils
 makemode := utilities
 
-targets = reboot halt fsck
-SRCS = reboot.c halt.c fsck.c fstab.c clookup.c
+targets = reboot halt fsck e2os
+special-targets = e2os
 installationdir = $(sbindir)
+SCRIPTS = e2os.sh
+SRCS = reboot.c halt.c fsck.c fstab.c clookup.c $(SCRIPTS)
+LCLHDRS = fstab.h
 
-OBJS = $(SRCS:.c=.o)
+OBJS = $(filter-out $(SCRIPTS),$(SRCS:.c=.o))
 
 include ../Makeconf
 
-fsck: fstab.o clookup.o ../libshouldbeinlibc/libshouldbeinlibc.a
+fsck: fstab.o clookup.o
+reboot halt fsck: ../libshouldbeinlibc/libshouldbeinlibc.a
 
-%: %.sh
-	cp $< $@
+%: %.sh $(top_srcdir)/sh-version.sed
+	sed -f $(top_srcdir)/sh-version.sed < $< > $@
 
 $(filter-out $(special-targets), $(targets)): %: %.o
Only in hurd-0.1/sutils: e2os.sh
diff -ru hurd-0.0/sutils/fsck.c hurd-0.1/sutils/fsck.c
--- hurd-0.0/sutils/fsck.c	Sat Jul  6 19:55:19 1996
+++ hurd-0.1/sutils/fsck.c	Thu Sep  5 11:43:46 1996
@@ -51,10 +51,12 @@
 #include <argp.h>
 #include <argz.h>
 #include <assert.h>
+#include <version.h>
 
 #include "fstab.h"
 
-char *argp_program_version = "fsck 1.0 (GNU " HURD_RELEASE ")";
+char *argp_program_version = STANDARD_HURD_VERSION (fsck);
+
 
 /* for debugging  */
 static int _debug = 0;
@@ -454,7 +456,7 @@
   {0, 0}
 };
 static const char *args_doc = "[ DEVICE|FSYS... ]";
-static const char *doc = 0;
+static const char *doc = "Filesystem consistency check and repair";
 
 int
 main (int argc, char **argv)
Only in hurd-0.1/sutils: fstab.h
diff -ru hurd-0.0/sutils/halt.c hurd-0.1/sutils/halt.c
--- hurd-0.0/sutils/halt.c	Wed Nov 16 20:29:18 1994
+++ hurd-0.1/sutils/halt.c	Thu Sep  5 11:51:45 1996
@@ -1,5 +1,5 @@
 /* Halt the system
-   Copyright (C) 1994 Free Software Foundation, Inc.
+   Copyright (C) 1994, 1996 Free Software Foundation, Inc.
    Written by Michael I. Bushnell.
 
    This file is part of the GNU Hurd.
@@ -22,10 +22,17 @@
 #include <sys/reboot.h>
 #include <unistd.h>
 #include <stdio.h>
+#include <argp.h>
+#include <hurd.h>
+#include <version.h>
+
+char *argp_program_version = STANDARD_HURD_VERSION (halt);
 
 int
-main (void)
+main (int argc, char *argv[])
 {
+  struct argp argp = {0, 0, 0, "Halt the system"};
+  argp_parse (&argp, argc, argv, 0, 0, 0);
   reboot (RB_HALT);
   perror ("reboot");
   return 1;
diff -ru hurd-0.0/sutils/reboot.c hurd-0.1/sutils/reboot.c
--- hurd-0.0/sutils/reboot.c	Wed Nov 16 20:28:36 1994
+++ hurd-0.1/sutils/reboot.c	Thu Sep  5 11:43:28 1996
@@ -1,5 +1,5 @@
 /* Reboot the system
-   Copyright (C) 1994 Free Software Foundation, Inc.
+   Copyright (C) 1994, 1996 Free Software Foundation, Inc.
    Written by Michael I. Bushnell.
 
    This file is part of the GNU Hurd.
@@ -22,15 +22,18 @@
 #include <sys/reboot.h>
 #include <unistd.h>
 #include <stdio.h>
+#include <argp.h>
+#include <hurd.h>
+#include <version.h>
+
+char *argp_program_version = STANDARD_HURD_VERSION (reboot);
 
 int
-main (void)
+main (int argc, char *argv[])
 {
+  struct argp argp = {0, 0, 0, "Reboot the system"};
+  argp_parse (&argp, argc, argv, 0, 0, 0);
   reboot (0);
   perror ("reboot");
   return 1;
 }
-
-  
-  
-  
diff -ru hurd-0.0/tasks hurd-0.1/tasks
--- hurd-0.0/tasks	Sat Jul 13 16:00:33 1996
+++ hurd-0.1/tasks	Tue Sep  3 15:02:16 1996
@@ -1,7 +1,7 @@
-GNU Hurd Task List Version 1.15.  Last updated 13 July 1996.
+GNU Hurd Task List Version 1.17.  Last updated 3 September 1996.
 
 If you would like to work on one of these, please contact
-mib@gnu.ai.mit.edu.  It's important that you let me know what's being
+thomas@gnu.ai.mit.edu.  It's important that you let me know what's being
 worked on, because someone else might also be interested, and you
 should coordinate work.
 
@@ -48,10 +48,6 @@
   in functionality to the Unix ITIMER_PROF and ITIMER_VIRTUAL timers.
 
 !!!
-  * Mach 3.0 needs to provide a way for users to do statistical PC
-  profiling similar to the Unix profil system call.
-
-!!!
   * Mach 3.0 needs to make switches from MEMORY_OBJECT_COPY_DELAY to
   MEMORY_OBJECT_COPY_NONE have the effect of immediately completing any
   delayed copies.
@@ -120,6 +116,8 @@
   * Add a timestamp for task and thread creation to the relevant info
   structures (and make sure it works for the kernel task and threads).
 
+  * Add an anonymous swap allocation statistic to the task info structure.
+
 
 Hurd work (these are brief descriptions; mib can give more information):
 
@@ -152,7 +150,6 @@
   * Filesystem implementations (using libdiskfs) for other popular
   formats.  Importantly, MSDOS FAT format.
   
-
   * Transparent FTP translator.
 
   * A fancy terminal driver that uses readline and supports detach/attach.
diff -ru hurd-0.0/term/ChangeLog hurd-0.1/term/ChangeLog
--- hurd-0.0/term/ChangeLog	Mon Jul 29 12:40:07 1996
+++ hurd-0.1/term/ChangeLog	Thu Aug 29 17:32:37 1996
@@ -1,3 +1,37 @@
+Thu Aug 29 17:26:37 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* devio.c (device_open_reply): After error from ports_create_port,
+	unlock global_lock before returning.
+	* users.c (trivfs_S_io_readable): Likewise before returning
+	EBADF. 
+
+Thu Aug 15 16:07:07 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* users.c (trivfs_S_io_pathconf): Implement function.
+
+	* term.h (QUEUE_HIWAT, QUEUE_LOWAT): New macros.
+	* main.c (main): Use these new macros to create inputq, rawq, and
+	outputq.
+
+Thu Aug 15 15:32:47 1996  Miles Bader  <miles@gnu.ai.mit.edu>
+
+	* users.c (trivfs_S_file_check_access): Renamed from
+	`trivfs_S_file_access'.
+
+Mon Aug 12 11:04:28 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* term.h (CTRL_BIT): Correct value is 0x40, not 0x20.
+
+	* munge.c (poutput): Compute tab width using the same loop
+	strategy as output_character and output_width.
+
+Thu Aug  8 17:16:06 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* munge.c (echo_char): Compute non-ctrl version of control
+	character correctly.
+	* term.h (CHAR_SOH): Delete macro.
+	(CTRL_BIT): New macro.
+
 Mon Jul 29 02:46:12 1996  Roland McGrath  <roland@baalperazim.frob.com>
 
 	* munge.c (input_character): In LAST_LNEXT case, jump to `alldone'
diff -ru hurd-0.0/term/devio.c hurd-0.1/term/devio.c
--- hurd-0.0/term/devio.c	Thu Jun 20 16:45:53 1996
+++ hurd-0.1/term/devio.c	Thu Aug 29 17:44:03 1996
@@ -468,7 +468,10 @@
 			     sizeof (struct port_info),
 			     &phys_reply_writes_pi);
   if (errno)
-    return errno;
+    {
+      mutex_unlock (&global_lock);
+      return errno;
+    }
   phys_reply_writes = ports_get_right (phys_reply_writes_pi);
   mach_port_insert_right (mach_task_self (), phys_reply_writes,
 			  phys_reply_writes, MACH_MSG_TYPE_MAKE_SEND);
diff -ru hurd-0.0/term/main.c hurd-0.1/term/main.c
--- hurd-0.0/term/main.c	Tue Jul 16 20:56:38 1996
+++ hurd-0.1/term/main.c	Thu Aug 15 16:07:37 1996
@@ -180,9 +180,9 @@
   term_owner = term_group = 0;
   term_mode = (bottom == &ptyio_bottom ? 0666 : 0600) | S_IFCHR;
 
-  inputq = create_queue (256, 100, 300);
-  rawq = create_queue (256, 100, 300);
-  outputq = create_queue (256, 100, 300);
+  inputq = create_queue (256, QUEUE_LOWAT, QUEUE_HIWAT);
+  rawq = create_queue (256, QUEUE_LOWAT, QUEUE_HIWAT);
+  outputq = create_queue (256, QUEUE_LOWAT, QUEUE_HIWAT);
   
   if (bottom == &ptyio_bottom)
     ptyio_init ();
diff -ru hurd-0.0/term/munge.c hurd-0.1/term/munge.c
--- hurd-0.0/term/munge.c	Mon Jul 29 12:40:08 1996
+++ hurd-0.1/term/munge.c	Mon Aug 12 11:06:48 1996
@@ -49,7 +49,11 @@
   else if (c == '\r')
     output_psize = 0;
   else if (c == '\t')
-    output_psize += (output_psize + 8) % 8;
+    {
+      output_psize++;
+      while (output_psize % 8)
+	output_psize++;
+    }
   else if (c == '\b')
     output_psize--;
 
@@ -131,7 +135,7 @@
       int n = loc + 1;
       while (n % 8)
 	n++;
-      return n;
+      return n; 
     }
   if ((c >= ' ') && (c < '\177'))
     return 1;
@@ -229,7 +233,7 @@
       if (echo_double (c, quoted))
 	{
 	  output_character ('^');
-	  output_character (c + ('A' - CHAR_SOH));
+	  output_character (c ^ CTRL_BIT);
 	}
       else
 	output_character (c);
diff -ru hurd-0.0/term/term.h hurd-0.1/term/term.h
--- hurd-0.0/term/term.h	Tue Jul 16 20:49:22 1996
+++ hurd-0.1/term/term.h	Thu Aug 15 16:06:41 1996
@@ -33,13 +33,15 @@
 #undef NOFLSH
 #include <termios.h>
 
-#define CHAR_SOH '\001'		/* C-a */
 #define CHAR_EOT '\004'		/* C-d */
 #define CHAR_DC1 '\021'		/* C-q */
 #define CHAR_DC2 '\022'		/* C-r */
 #define CHAR_DC3 '\023'		/* C-s */
 #define CHAR_USER_QUOTE '\377'	/* break quoting, etc. */
 
+/* This bit specifies control */
+#define CTRL_BIT 0x40
+
 /* XXX These belong in <termios.h> */
 #define ILCASE (1 << 14)
 #define OLCASE (1 << 9)
@@ -67,6 +69,9 @@
 #define EXCL_USE          0x00000100 /* user accessible exclusive use */
 #define NO_OWNER          0x00000200 /* there is no foreground_id */
 #define ICKY_ASYNC	  0x00000400 /* some user has set O_ASYNC */
+
+#define QUEUE_LOWAT 100
+#define QUEUE_HIWAT 300
 
 /* Global lock */
 struct mutex global_lock;
diff -ru hurd-0.0/term/users.c hurd-0.1/term/users.c
--- hurd-0.0/term/users.c	Fri Jul 19 23:46:26 1996
+++ hurd-0.1/term/users.c	Thu Aug 29 17:32:22 1996
@@ -515,10 +515,9 @@
 
 
 error_t
-trivfs_S_file_access (struct trivfs_protid *cred,
-		      mach_port_t reply,
-		      mach_msg_type_name_t reply_type,
-		      int *allowed)
+trivfs_S_file_check_access (struct trivfs_protid *cred,
+			    mach_port_t reply, mach_msg_type_name_t reply_type,
+			    int *allowed)
 {
   if (!cred)
     return EOPNOTSUPP;
@@ -743,6 +742,46 @@
 }
 
 error_t
+trivfs_S_io_pathconf (struct trivfs_protid *cred,
+		      mach_port_t reply,
+		      mach_msg_type_name_t reply_type,
+		      int name,
+		      int *val)
+{
+  if (!cred)
+    return EOPNOTSUPP;
+  
+  switch (name)
+    {
+    case _PC_LINK_MAX:
+    case _PC_NAME_MAX:
+    case _PC_PATH_MAX:
+    case _PC_PIPE_BUF:
+    case _PC_NO_TRUNC:
+    default:
+      return io_pathconf (cred->realnode, name, val);
+      
+    case _PC_MAX_CANON:
+      *val = rawq->hiwat;
+      return 0;
+      
+    case _PC_MAX_INPUT:
+      *val = inputq->hiwat;
+      return 0;
+      
+    case _PC_CHOWN_RESTRICTED:
+      /* We implement this locally, remember... */
+      *val = 1;
+      return 0;
+      
+    case _PC_VDISABLE:
+      *val = _POSIX_VDISABLE;
+      return 0;
+    }
+}    
+
+
+error_t
 trivfs_S_io_readable (struct trivfs_protid *cred,
 		      mach_port_t reply,
 		      mach_msg_type_name_t replytype,
@@ -756,7 +795,10 @@
 
   mutex_lock (&global_lock);
   if ((cred->po->openmodes & O_READ) == 0)
-    return EBADF;
+    {
+      mutex_unlock (&global_lock);
+      return EBADF;
+    }
   *amt = qsize (inputq);
   if (remote_input_mode && *amt)
     --*amt;
diff -ru hurd-0.0/ufs/ChangeLog hurd-0.1/ufs/ChangeLog
--- hurd-0.0/ufs/ChangeLog	Mon Jul 29 12:40:15 1996
+++ hurd-0.1/ufs/ChangeLog	Fri Sep  6 16:02:50 1996
@@ -1,3 +1,55 @@
+Fri Sep  6 16:00:42 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* consts.c: Include <version.h>.
+ 	(diskfs_major_version, diskfs_minor_version, diskfs_edit_version):
+	Deleted variables. 
+	(diskfs_server_version): New variable.
+
+Thu Aug 29 16:07:07 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* dir.c (diskfs_lookup_hard): When setting ds->stat to EXTEND, set
+	ds->idx by looking at the size of the file.  (IDX itself is no
+	longer at the end because of the change on Aug 16 1996.) 
+
+Wed Aug 28 12:15:15 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* dir.c (dirscanblock): Size dirents correctly when mallocing it.
+	(diskfs_direnter_hard): Be more careful when sizing or resizing
+	dirents.  Correctly set to -1 all the new entries we create after
+	realloc call.   
+
+Fri Aug 16 18:51:31 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* ufs.h (struct disknode): New member `dir_idx'.
+	* inode.c (diskfs_cached_lookup): Initialize DN->dir_idx.
+	* dir.c (diskfs_lookup_hard): 	After successful dirscanblock,
+	record index where we finished in DP->dn->dir_idx.  Start searches
+	at that index.
+
+Mon Aug 12 13:43:46 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* hyper.c (diskfs_set_hypermetadata): Bother to return 0 at end of
+	function.
+
+Wed Aug  7 13:00:30 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* inode.c (diskfs_set_statfs): Compute st->f_blocks correctly; set
+	bsize to be fs_fsize, not fs_bsize.
+
+	* hyper.c (diskfs_set_hypermetadata): Return an error as
+	appropriate. 
+	
+	* inode.c (struct ufs_fhandle): Layout filehandle more like Unixy
+	NFSD. 
+ 	(diskfs_S_file_getfh): Bother to clear unused parts of a
+	file handle so that they always compare equal.
+
+Tue Aug  6 12:19:38 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* inode.c: Include <fcntl.h>.
+	(struct ufs_fhandle): New type.
+	(diskfs_S_fsys_getfile, diskfs_S_file_getfh): New functions.
+
 Tue Jul 23 15:58:28 1996  Miles Bader  <miles@gnu.ai.mit.edu>
 
 	* inode.c (write_node, read_disknode): `struct timespec' now uses
diff -ru hurd-0.0/ufs/consts.c hurd-0.1/ufs/consts.c
--- hurd-0.0/ufs/consts.c	Mon Mar 20 13:58:39 1995
+++ hurd-0.1/ufs/consts.c	Fri Sep  6 16:04:15 1996
@@ -1,5 +1,5 @@
 /* Various constants wanted by the diskfs library
-   Copyright (C) 1994, 1995 Free Software Foundation
+   Copyright (C) 1994, 1995, 1996 Free Software Foundation
 
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
@@ -16,6 +16,7 @@
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */
 
 #include "ufs.h"
+#include <version.h>
 
 int diskfs_link_max = LINK_MAX;
 int diskfs_maxsymlinks = 8;
@@ -25,7 +26,5 @@
 int diskfs_shortcut_fifo = 1;
 int diskfs_shortcut_ifsock = 1;
 char *diskfs_server_name = "ufs";
-int diskfs_major_version = 0;
-int diskfs_minor_version = 0;
-int diskfs_edit_version = 0;
+char *diskfs_server_version = HURD_VERSION;
 int diskfs_synchronous = 0;
diff -ru hurd-0.0/ufs/dir.c hurd-0.1/ufs/dir.c
--- hurd-0.0/ufs/dir.c	Mon Jun 24 17:25:22 1996
+++ hurd-0.1/ufs/dir.c	Thu Aug 29 16:07:31 1996
@@ -111,7 +111,8 @@
   vm_address_t buf = 0;
   vm_size_t buflen = 0;
   int blockaddr;
-  int idx;
+  int idx, lastidx;
+  int looped;
   
   if ((type == REMOVE) || (type == RENAME))
     assert (npp);
@@ -156,18 +157,39 @@
   if (!diskfs_check_readonly ())
     dp->dn_set_atime = 1;
   
-  for (blockaddr = buf, idx = 0;
-       blockaddr - buf < dp->dn_stat.st_size;
-       blockaddr += DIRBLKSIZ, idx++)
+  /* Start the lookup at DP->dn->dir_idx.  */
+  idx = dp->dn->dir_idx;
+  if (idx * DIRBLKSIZ > dp->dn_stat.st_size)
+    idx = 0;			/* just in case */
+  blockaddr = buf + idx * DIRBLKSIZ;
+  looped = (idx == 0);
+  lastidx = idx;
+  if (lastidx == 0)
+    lastidx = dp->dn_stat.st_size / DIRBLKSIZ;
+
+  while (!looped || idx < lastidx)
     {
       err = dirscanblock (blockaddr, dp, idx, name, namelen, type, ds, &inum);
       if (!err)
-	break;
+	{
+	  dp->dn->dir_idx = idx;
+	  break;
+	}
       if (err != ENOENT)
 	{
 	  vm_deallocate (mach_task_self (), buf, buflen);
 	  return err;
 	}
+
+      blockaddr += DIRBLKSIZ;
+      idx++;
+      if (blockaddr - buf >= dp->dn_stat.st_size && !looped)
+	{
+	  /* We've gotten to the end; start back at the beginning */
+	  looped = 1;
+	  blockaddr = buf;
+	  idx = 0;
+	}
     }
 
   if (!diskfs_check_readonly ())
@@ -258,7 +280,7 @@
       /* We didn't find any room, so mark ds to extend the dir */
       ds->type = CREATE;
       ds->stat = EXTEND;
-      ds->idx = idx;
+      ds->idx = dp->dn_stat.st_size / DIRBLKSIZ;
     }
 
   /* Return to the user; if we can't, release the reference
@@ -422,8 +444,8 @@
 	 down how many entries there were. */
       if (!dp->dn->dirents)
 	{
-	  dp->dn->dirents = malloc ((dp->dn_stat.st_size / DIRBLKSIZ + 1) 
-				* sizeof (int));
+	  dp->dn->dirents = malloc ((dp->dn_stat.st_size / DIRBLKSIZ) 
+				    * sizeof (int));
 	  for (i = 0; i < dp->dn_stat.st_size/DIRBLKSIZ; i++) 
 	    dp->dn->dirents[i] = -1;
 	}
@@ -595,19 +617,26 @@
     }
   else
     {
+      int i;
       /* It's cheap, so start a count here even if we aren't counting
 	 anything at all. */
       if (dp->dn->dirents)
 	{
 	  dp->dn->dirents = realloc (dp->dn->dirents, 
-				     (ds->idx + 1) * sizeof (int));
+				     (dp->dn_stat.st_size / DIRBLKSIZ
+				      * sizeof (int)));
+	  for (i = oldsize / DIRBLKSIZ; 
+	       i < dp->dn_stat.st_size / DIRBLKSIZ;
+	       i++)
+	    dp->dn->dirents[i] = -1;
+
 	  dp->dn->dirents[ds->idx] = 1;
 	}
       else
 	{
-	  int i;
-	  dp->dn->dirents = malloc ((ds->idx + 1) * sizeof (int));
-	  for (i = 0; i < ds->idx; i++)
+	  dp->dn->dirents = malloc (dp->dn_stat.st_size / DIRBLKSIZ 
+				    * sizeof (int));
+	  for (i = 0; i < dp->dn_stat.st_size / DIRBLKSIZ; i++)
 	    dp->dn->dirents[i] = -1;
 	  dp->dn->dirents[ds->idx] = 1;
 	}
diff -ru hurd-0.0/ufs/hyper.c hurd-0.1/ufs/hyper.c
--- hurd-0.0/ufs/hyper.c	Mon Jun 24 17:23:42 1996
+++ hurd-0.1/ufs/hyper.c	Mon Aug 12 13:43:10 1996
@@ -276,7 +276,7 @@
    taken from ordinary data blocks and might not be an even number
    of pages; in that case writing it through the pager would nuke whatever
    pages came after it on the disk and were backed by file pagers. */
-void
+error_t
 diskfs_set_hypermetadata (int wait, int clean)
 {
   vm_address_t buf;
@@ -294,16 +294,22 @@
 
       err = diskfs_device_read_sync (fsbtodb (sblock, sblock->fs_csaddr),
 				     &buf, bufsize);
-      if (!err)
+      if (err)
+	return err;
+      
+      bcopy (csum, (void *) buf, sblock->fs_cssize);
+      if (swab_disk)
+	swab_csums ((struct csum *)buf);
+      err = diskfs_device_write_sync (fsbtodb (sblock, sblock->fs_csaddr),
+				      buf, bufsize);
+      vm_deallocate (mach_task_self (), buf, bufsize);
+      
+      if (err)
 	{
-	  bcopy (csum, (void *) buf, sblock->fs_cssize);
-	  if (swab_disk)
-	    swab_csums ((struct csum *)buf);
-	  diskfs_device_write_sync (fsbtodb (sblock, sblock->fs_csaddr),
-				    buf, bufsize);
-	  csum_dirty = 0;
-	  vm_deallocate (mach_task_self (), buf, bufsize);
+	  spin_unlock (&alloclock);
+	  return err;
 	}
+      csum_dirty = 0;
     }
 
   if (clean && ufs_clean && !sblock->fs_clean)
@@ -326,6 +332,7 @@
   copy_sblock ();
 
   sync_disk (wait);
+  return 0;
 }
 
 /* Copy the sblock into the disk */
